<div align="center">

![devchat](https://github.com/covespace/devchat/assets/592493/f39979fe-fe32-410b-bf9d-2118ac8ea3d5)

# DevChat

<br>

[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat-square)](http://makeapullrequest.com)
[![CircleCI](https://circleci.com/gh/covespace/devchat/tree/main.svg?style=shield)](https://circleci.com/gh/covespace/devchat/tree/main)
[![GitHub license](https://img.shields.io/github/license/covespace/devchat.svg)](https://github.com/covespace/devchat/blob/main/LICENSE)
[![Downloads](https://pepy.tech/badge/devchat)](https://pepy.tech/project/devchat)
[![PyPI version](https://badge.fury.io/py/devchat.svg)](https://badge.fury.io/py/devchat)
[![Discord Chat](https://img.shields.io/discord/1106908489114206309?logo=discord)](https://discord.gg/9t3yrbBUXD)

</div>
<br>
<div align="left">

The DevChat core library and CLI.

:point_right: For a better experience, check out our [Visual Studio Code extension](https://github.com/covespace/devchat-vscode) on [Visual Studio Marketplace](https://marketplace.visualstudio.com/items?itemName=merico.devchat)! Install and enjoy the enhanced UI :clap:



https://github.com/covespace/devchat/assets/592493/76e997fe-33a3-4fee-8f67-5523df90316e



***

## What is DevChat?

DevChat is an open-source tool that helps you write prompts to generate code and documentation.
It is _not_ limited to performing predefined operations on short code snippets.
  
DevChat is the way developers interact and collaborate with AI.

:speech_balloon: Build the future with prompts, _not_ code.

## Why DevChat?

- To enable AI to write code, DevChat assists you in providing **the right context** for AI.
  
  Chat history, code, files, directory trees, `git diff --cached`, or the output of any command.

  <img width="500" alt="image" src="https://github.com/covespace/devchat-vscode/assets/592493/415df4aa-66d6-46e4-a30d-8bba6277028c">
 
- To apply AI-generated code, DevChat streamlines your **actions to take**.

  View diffs, copy or insert, commit & sync, or export to documentation, wikis, and more.
  
  <img width="500" alt="image" src="https://github.com/covespace/devchat-vscode/assets/592493/bcccbf20-0d30-46f4-b19f-5f532c1caf85">
  
- To guide AI in your work, define **your own workflows** with DevChat.
  
  Prompt templates, iterative calls to AI, and program operations.

- To suit your preferences, customize **your own experiences** with DevChat.
  
  Open-source, no waiting for opaque feature schedules. Access GPT-4 today and more models in the future.
  
## What is Prompt-Centric Software Development (PSSD)?

- The traditional code-centric paradigm is evolving.

- Write prompts to create code. Transform prompts into everything.

- It is DevPromptOps
  
  <img width="500" alt="image" src="https://github.com/covespace/devchat/assets/592493/e8e1215b-53b0-4473-ab00-0665d33f204a">


***

## Quick Start

- Install DevChat by running: `pip install devchat`
- Make sure you are in a Git repository, as DevChat only works within one.
- To access help, use the commands: `devchat --help` and `devchat prompt --help`

## Community

- Join our [Discord](https://discord.gg/9t3yrbBUXD)!

- Participate in [discussions](https://github.com/covespace/devchat/discussions)!

## Roadmap

- [x] Implement code diff application.
- [ ] Improve code diff application using code change instructions.
- [ ] Develop a framework for defining workflows.
- [ ] Implement topic management.
- [ ] Enable interaction with external development tools.
- [ ] Introduce more selective workflows.
